// Klasse Konto


#include <vcl.h>
#include <math.h>

class Konto {
  private:
     int derKontostand;
  protected:
     AnsiString aKontoArt;
  public:
  Konto(int p_SBetrag);
  Konto(void);
  int gibKontostand(void);
  virtual void buchen(int p_Betrag);
  AnsiString gibKontoArt(void);
};

Konto::Konto(int p_SBetrag){
derKontostand = p_SBetrag;
}
Konto::Konto(void){
derKontostand = 0;
}
AnsiString Konto::gibKontoArt(void){
return aKontoArt;
}
int Konto::gibKontostand(void){
    return derKontostand;
}
void Konto::buchen(int p_Betrag){
derKontostand = derKontostand + p_Betrag;
}
//------------------------------------------------------
class Sparkonto : public Konto

{
public:
   Sparkonto(int p_Mindesteinlage);
   void buchen(int p_Betrag);
protected:
   int a_Mindesteinlage;
};

//Operationen
Sparkonto::Sparkonto(int p_Mindesteinlage){
Konto::buchen(p_Mindesteinlage);
a_Mindesteinlage =  p_Mindesteinlage;
aKontoArt = "Sparkonto";
}

void Sparkonto::buchen(int p_Betrag){
if(Konto::gibKontostand()-a_Mindesteinlage+p_Betrag >= 0)
        Konto::buchen(p_Betrag);

}
//---------------------------------------------------------------------------

class Girokonto : public Konto
{
public:
   Girokonto(int p_Kreditlimit);
   Girokonto(void);
   void buchen(int p_Betrag);
protected:
   int a_Kreditlimit;
};

//Operationen
Girokonto::Girokonto(int p_Kreditlimit){

a_Kreditlimit =  - p_Kreditlimit;
aKontoArt = "Girokonto";
}

Girokonto::Girokonto(void){

a_Kreditlimit =  0.00;
aKontoArt = "Girokonto";
}

void Girokonto::buchen(int p_Betrag){
if(Konto::gibKontostand() + p_Betrag >= a_Kreditlimit)
         Konto::buchen(p_Betrag);
}

//------------------------------------------------------

class Festgeldkonto : public Konto

{
public:
   Festgeldkonto(int p_AnlageBetrag, int pLaufzeit, float pZinssatz);
   void buchen(int p_Betrag);
   int gibRestlaufzeit(void);
   void vermindereRestlaufzeit(void);
protected:
   int a_Restlaufzeit;

};

//Operationen
Festgeldkonto::Festgeldkonto(int p_AnlageBetrag, int pLaufzeit, float pZinssatz){
float Zinsen = (pZinssatz/100)*p_AnlageBetrag*(pLaufzeit/360.0);
int pBetrag = floor(Zinsen+0.5)+p_AnlageBetrag ;
Konto::buchen(pBetrag);
aKontoArt = "Festgeldkonto";
a_Restlaufzeit = pLaufzeit;
}

void Festgeldkonto::vermindereRestlaufzeit(void){
a_Restlaufzeit = a_Restlaufzeit-1;
}

int Festgeldkonto::gibRestlaufzeit(void){
return a_Restlaufzeit;
}


void Festgeldkonto::buchen(int p_Betrag){
if(Konto::gibKontostand()+p_Betrag >= 0 && a_Restlaufzeit <= 0)
        Konto::buchen(p_Betrag);
}

